<?php

namespace crisu83\yii_caviar;

class Compiler extends \CComponent
{
    /**
     * Compiles a template using the given data.
     *
     * @param string $template
     * @param array $data
     * @return string
     */
    public function compile($template, $data)
    {
        foreach ($data as $key => $value) {
            $template = preg_replace("/\\$$key\\$/i", $value, $template);
        }

        return preg_replace('/(<?php)/', "$1\n" . $this->renderBanner(), $template, 1);
    }

    /**
     * Renders the banner that is prepended to each generated file.
     *
     * @return string the rendered banner.
     */
    protected function renderBanner()
    {
        return <<<EOD
/**
 * This file was generated by Caviar.
 * http://github.com/Crisu83/yii-caviar
 */
EOD;
    }
} 